#include "hclib.h"
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include "calc.h"

double INF, IND;

void writenum(double wht,short ns){
  fwritenum(stdout,wht,ns);
}
extern short fastlog15(short ns){
  switch(ns){
    case 2:return 50;
    case 3:return 32;
    case 4:return 25;
    case 5:return 22;
    case 6:return 20;
    case 7:return 18;
    case 8:return 17;
    case 9:return 16;
    case 10:
    case 11:return 15;
    case 12:
    case 13:
    case 14:
      return 14;
    case 15:
    case 16:
    case 17:
      return 13;
    default: return 12;
  }
}
void fwritenum(FILE *f,double wht, short ns){
  double m;
  short n, N, n0, _w=0, v=1025;
// ! 51 = 50 + 1 =    
  char w[51], dw=0;
  if(ns<=0||ns>36){
    fprintf(f,"hCalc.Write: unknown number system");
    return;
  }
  if(!wht){
    fprintf(f,"0");
    return;
  }
  if(wht==INF){
    fprintf(f,"INF");
    return;
  }
  if(wht==-INF){
    fprintf(f,"-INF");
    return;
  }
  if(indef(wht)){
    fprintf(f,"IND");
    return;
  }
  N=fastlog15(ns);
  n0=N;
  if(wht<0){
    fprintf(f,"-");
    wht=-wht;
  }
  while(wht<pow(ns,v))v--;
  if(v<-1){
    fprintf(f,"0.");
    for(m=v+1;m<0;m++,fprintf(f,"0"));
  }
  while(v>=0){
    m=pow(ns,v);
    n=0;
    while(wht>=m){
      n++;
      wht-=m;
    }
    if(n<10)fprintf(f,"%d",n);
    else fprintf(f,"%c",n-10+'a');
    if(N)N--;
    v--;
  }
  if(v==-1){
    if(N==n0)fprintf(f,"0");
    if(N)dw=1;
  }
  while(N&&v>-308){
    m=pow(ns,v);
    n=0;
    while(wht>=m){
      n++;
      wht-=m;
    }
    if(n<10)w[_w]=n+48;
    else w[_w]=n-10+'a';
    _w++;
    N--;
    v--;
  }
  w[_w]=0;
  _w--;
  while(_w>=0&&(w[_w]==48||!w[_w])){
    w[_w]=0;
    _w--;
  }
  if(*w&&dw)fprintf(f,".");
  fprintf(f,"%s",w);
}
void winwords(unsigned char str[]){
  int l,len;
  if(str==NULL)return;
  len=(int)strlen(str);
  if(len==0)return;
  for (l=0;l<len;l++){
    if((str[l]>=0xc0)&&(str[l]<0xf0))printf("%c",str[l]-0x40);
    else if(str[l]>=0xf0)printf("%c",str[l]-0x10);
    else if(str[l]==168)printf("%c",240);
    else if(str[l]==184)printf("%c",241);
    else printf("%c",str[l]);
  }
}
void Strncpy(unsigned char *dest,unsigned char *sou, unsigned long max){
  dest[0]=0;
  if(!max)return;
  dest[max]=0;
  while(max>0){
    max--;
    dest[max]=sou[max];
  }
}
void delspace(unsigned char *str){
  unsigned long i=0,n=0;
  while(str[n]&&!isspace(str[n]))n++;
  if(!str[n])return;
  n=0;
  while(str[n]){
    while(isspace(str[n]))n++;
    str[i]=str[n];
    i++;
    n++;
  }
  str[i]=0;
  if(i!=n){
    if(err)winwords(" : ");
    printf("%s;\n",str);
  }
}

void mystr(unsigned char *str,unsigned char *title,unsigned char *end){
  int i;
  winwords(title);
  printf("\"");
  for(i=0;str+i<end;){
    if(str[i]==_F){
      printf("%g",*((double*)(str+i+1)));
      i+=sizeof(double)+1;
    }else printf("%c",str[i]);
    i++;
  }
  printf("\"\n");
}
int msymb(unsigned char a){
  if(a=='^'||a=='+'||a=='-'||a=='*'||a=='/'||a=='='||a=='<'||a=='>'||a=='!'||a=='?'||a=='&'||a=='|'||a=='('||a==')'||a==','||a==';'||a=='['||a==']'||a=='{'||a=='}'||a==':'||a=='\'')return 1;
  else return 0;
}
int msymb1(unsigned char a){
  if(a=='^'||a=='+'||a=='-'||a=='*'||a=='/'||a=='='||a=='!'||a=='?'||a=='&'||a=='|'||a==','||a==';'||a=='['||a==']'||a=='{'||a=='}'||a==':'||a=='\'')return 1;
  else return 0;
}
int geq(unsigned char a,unsigned char b){
  if(((a=='<'&&msymb(b)&&b!='='&&b!='>')||(a=='>'&&msymb(b)&&b!='=')||(a=='='&&msymb(b)))&&b!='('){
    if(err)winwords("   ");
    if(err)printf("\"%c%c\".\n",a,b);
    return 0;
  }
  return 1;
}
int goodmath(unsigned char *command){
  unsigned long i,n;
  if(!command)return 1;
  if(!command[0]||!command[1])return 0;
  delspace(command);

  i=0;
  n=0;
  while(command[i]&&command[i]!=_F){
    if(command[i]=='(')n++;
    else if(command[i]==')')n--;
    i++;
  }
  if(err&&command[i]==_F){
    winwords("   ");
    printf("#%d (%c) ",_F,_F);
    winwords("  .\n");
    return 1;
  }
  if(err&&n){
    winwords("     ");
    printf("\"%s\"\n",command);
    return 1;
  }
/*
  i=0;
  while(command[i+1]&&!(msymb1(command[i+1])&&msymb1(command[i])&&command[i]!=',')&&geq(command[i],command[i+1]))i++;
  if(command[i+1]){
    winwords(" :  ");
    printf("%d \"%c%c\".\n",i+1,command[i],command[i+1]);
    return 1;
  }*/
  return 0;
}
void _command(unsigned char **cmd, unsigned char *str){
  (*cmd)=str;
  while((*cmd)[0]&&isspace((*cmd)[0]))(*cmd)++;
}
void leftdel(unsigned char *a,unsigned long m,unsigned long max){
  unsigned long n;
  for(n=0;n<max;n++)a[n]=a[n+m];
}
void leftins(unsigned char *b,unsigned char *a, unsigned long a_,unsigned long max){
  if (a_<=0)return;
  while(max>0){
    max-=1;
    b[max+a_]=b[max];
  }
  while(a_>0){
    a_-=1;
    b[a_]=a[a_];
  }
}
void leftinsch(unsigned char *b,unsigned char a,unsigned long max){
  while(max>0){
    max-=1;
    b[max+1]=b[max];
  }
  b[0]=a;
}
void get_command(unsigned char *line, unsigned char *commands, unsigned char div){
  unsigned long i=0,l=0;
  while(commands[i]&&isspace(commands[i]))i++;
  while(commands[i]&&commands[i]!=div){
    line[l]=commands[i];
    i++;
    l++;
  }
  line[l]=0;
  if(commands[i]==div)i++;
  strcpy(commands,commands+i);
  i=(unsigned long)strlen(line)-1;
  while(isspace(line[i]))i--;
  i++;
  line[i]=0;
  i=0;
  while(isspace(commands[i]))i++;
  if(!commands[i])commands[0]=0;
}
int isstfun(unsigned char *var){
  if(!strcmp(var,"SIN")||!strcmp(var,"COS")||!strcmp(var,"TG")||!strcmp(var,"CTG"))return 1;
  if(!strcmp(var,"ARCSIN")||!strcmp(var,"ARCCOS")||!strcmp(var,"ARCTG")||!strcmp(var,"ARCCTG"))return 1;
  if(!strcmp(var,"SH")||!strcmp(var,"CH")||!strcmp(var,"TH")||!strcmp(var,"CTH"))return 1;
  if(!strcmp(var,"EXP")||!strcmp(var,"LOG")||!strcmp(var,"LG")||!strcmp(var,"LN"))return 1;
  if(!strcmp(var,"ABS")||!strcmp(var,"IND")||!strcmp(var,"FKT")||!strcmp(var,"ARG"))return 1;
  if(!strcmp(var,"INT")||!strcmp(var,"FRAC")||!strcmp(var,"RND")||!strcmp(var,"IF"))return 1;
  if(!strcmp(var,"AVR")||!strcmp(var,"AVR#")||!strcmp(var,"SUM")||!strcmp(var,"SUM#"))return 1;
  return 0;
}
int notvar(unsigned char *var){
  double val;
  
  if(!var)return 1;
  if(!var[0])return 1;
  if(var[0]==_F)return 1;
  val=str2d(var,(unsigned long)strlen(var));
  if(!indef(val))return 1;
  
  if(!strcmp(var,"PI"))return 1;
  if(!strcmp(var,"E"))return 1;
  if(!strcmp(var,"INF"))return 1; 
  if(!strcmp(var,"IND"))return 1;
  if(!strcmp(var,"RND"))return 1;
  if(!strcmp(var,"ARGS"))return 1;
  if(!strcmp(var,"ARGN"))return 1;
  while(var[0]&&!msymb(var[0]))var++;
  if(msymb(var[0]))return 1;
  if(var[strlen(var)-1]=='$')return 1;
  return 0;
}
int notfun(unsigned char *var){
  double val;
  
  if(!var)return 1;
  if(!var[0])return 1;
  if(var[0]==_F)return 1;
  /*
  val=str2d(var,(unsigned long)strlen(var));
  if(!indef(val))return 1;
  */
  
  if(isstfun(var))return 1;
  while(var[0]&&!msymb(var[0]))var++;
  if(msymb(var[0]))return 1;
  if(var[strlen(var)-1]=='$')return 1;
  return 0;
}
double str2d(unsigned char *str, unsigned long max){
  unsigned long i;
  char ns=10;
  double res=0, tmp=1;
  if(!str||max<=0)return IND;
  if(str[0]&&str[1]){
  switch(str[max-1]){
    case 'B': ns=2;break;
    case 'O': ns=8;break;
    case 'D': ns=10;break;
    case 'H': ns=16;break;
    default:
      i=max-1;
      while(i&&str[i]!='#')i--;
      if(str[i]=='#'&&i>0){
        i++;
        res=str2d(str+i,max-i);
        if(indef(res))return IND;
        if(res>36||res<2)return IND;
        res=res-Frac(res);
        ns=(char)res;
        max=i;
      }else max++;
      break;
  }
  max--;
  }
  res=0;
  i=0;
  while(i<max&&str[i]){
    if(str[i]!='.')res*=(double)ns;
    if(str[i]>=48&&str[i]<=57){
      if(str[i]-48<ns)res+=(double)(str[i]-48);
      else return IND;
    }else if(str[i]>='a'&&str[i]<='z'){
      if(str[i]-'a'+10<ns)res+=(double)(str[i]-'a'+10);
      else return IND;
    }else break;
    i++;
  }
  if(i==max)return res;
  if(str[i]!='.')return IND;
  i++;
  while(i<max&&str[i]){
    tmp/=(double)ns;
    if(str[i]>=48&&str[i]<=57){
      if(str[i]-48<ns)res+=tmp*(double)(str[i]-48);
      else return IND;
    }else if(str[i]>='a'&&str[i]<='z'){
      if(str[i]-'a'+10<ns)res+=tmp*(double)(str[i]-'a'+10);
      else return IND;
    }else return IND;    
    i++;
  }
  if(i<max&&str[i]=='.')return IND;
  return res;
}
int indef(double a){
  char i=0;
  while(i<sizeof(double)&&((char*)&a)[i]==((char*)&IND)[i])i++;
  if(i<sizeof(double))
    return 0;
  else 
    return 1;
}
static double _frac(double a){
  double v=308, m;
  if(a>pow(10,v))return INF;
  if(a<1)return IND;
  while(v>=0&&a){
    m=pow(10,v);
    while(a-m>=0)a-=m;
    v--;
  }
  return a;
}
double Frac(double a){
  if(a==INF||a==-INF)return 0;
  if(a>=0&&a<1)return a;
  if(a>-1&&a<0)return 1+a;
  if(a>0)return _frac(a);
  else{
    a=1-_frac(-a);
    if(a==1)return 0;
    else return a;
  }
}
double fkt(double a){
  double i;
  if(a<0)return IND;
  if(a==0)return 1;
  if(a==INF)return INF;
  i=a-Frac(a);
  a=i;
  while(i>1&&a<INF){
    i--;
    a*=i;
  }
  return a;
}
double Mod(double a, double b){
  return Frac(a/b)*b;
}
double Div(double a,double b){
  return a/b-Frac(a/b);
}