#include "calc.h"
#include "hclib.h"

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <conio.h>
#include <time.h>
#include <ctype.h>

time_t Time=0;

void write(double wht){
  size_t i=0;
  long s;
  char *end;
#define MAXBUF 32
  char buf[MAXBUF+1];
  while(wrformat[i]){
    switch(wrformat[i]){
      case '%':
        s=(long)i+1;
        while(wrformat[s]&&wrformat[s]!='%'&&(wrformat[s]<'a'||wrformat[s]>'z')&&(wrformat[s]<'A'||wrformat[s]>'Z')&&s-i<MAXBUF)s++;
        strncpy(buf,wrformat+i,s-i+1);
        buf[s-i+1]=0;
        printf(buf,wht);
        i=s;
        break;
      case '#':
        i++;
        if(wrformat[i]=='#')printf("#");
        else if(wrformat[i]=='L')printf("\n");
        else if(wrformat[i]=='T')printf("\t");
        else{
          s=strtol(wrformat+i,&end,10);
          i=end-wrformat-1;
          printf("%c",s);
        }
        break;
      case '$':
        i++;
        if(wrformat[i]=='$')printf("$");
        else if(wrformat[i]=='B')writenum(wht,2);
        else if(wrformat[i]=='O')writenum(wht,8);
        else if(wrformat[i]=='H')writenum(wht,16);
        else if(wrformat[i]=='D')writenum(wht,10);
        else{
          s=strtol(wrformat+i,&end,10);
          if(s<2||s>36)printf("$ERROR[%d]",s);
          else{
            i=end-wrformat-1;
            writenum(wht,(short)s);
          }
        }
        break;
      default:
        printf("%c",wrformat[i]);
        break;
    }
    i++;
  }
}
int chmem(unsigned long newsize){
  if(!data||max==0)
    data=(double *)malloc(newsize*sizeof(double));
  else{
    double *tmp=(double *)realloc(data,newsize*sizeof(double));
    if(!tmp)return 1;
    data=tmp;
  }
  if(!data){
    max=0;
    size=0;
    return 1;
  }
  if(!name||max==0)
    name=(unsigned char *)malloc(newsize*namelen);
  else{
    unsigned char *tmp=(unsigned char *)realloc(name,newsize*namelen);
    if(!tmp)return 1;
    name=tmp;
  }
  if(!name){
    free(data);
    size=0;
    max=0;
    return 1;
  }
  max=newsize;
  return 0;
}
int getmem(unsigned long newsize){
  if(newsize<max)return 0;
  return chmem(newsize);
}
int chfmem(unsigned long newsize){
  if(!ftext||fmax==0)
    ftext=(unsigned char**)malloc(newsize*sizeof(unsigned char *));
  else{
    unsigned char **tmp=ftext=(unsigned char**)realloc(ftext,newsize*sizeof(unsigned char *));
    if(!tmp)return 1;
    ftext=tmp;
  }
  if(!ftext){
    fmax=0;
    fsize=0;
    return 1;
  }
  if(!fname||fmax==0)
    fname=(unsigned char *)malloc(newsize*namelen);
  else{
    unsigned char *tmp=(unsigned char *)realloc(fname,newsize*namelen);
    if(!tmp)return 1;
    fname=tmp;
  }
  if(!fname){
    free(ftext);
    fsize=0;
    fmax=0;
    return 1;
  }
  fmax=newsize;
  return 0;
}
int getfmem(unsigned long newsize){
  if(newsize<fmax)return 0;
  return chfmem(newsize);
}
void load(unsigned char *filename){
  unsigned long s,fs;
  unsigned char ver[verlen]="";
  FILE *f;
  winwords("  ");
  printf("%s...\n",filename);
  f=fopen(filename,"rb");
  if(!f){
    winwords("     .\n");
    return;
  }
  if(fread(ver,strlen(FILE_VER),1,f)!=1){
    winwords("    .\n");
    return;
  }
  if(strcmp(ver,FILE_VER)){
    fclose(f);
    winwords("    (): ");
    printf("%s\n",ver);
    winwords("   h!CAlC - ");
    printf("%s\n",FILE_VER);
    return;
  }
  if(fread(&s,sizeof(unsigned long),1,f)!=1){
    winwords("    .\n");
    return;
  }
  if(s){
    getmem(s);
    if(fread(data,s*sizeof(double),1,f)!=1||fread(name,s*namelen,1,f)!=1){
      winwords("     .\n");
      fclose(f);
      return;
    }
  }
  size=s;
  if(fread(&fs,sizeof(unsigned long),1,f)!=1){
    winwords("    .\n");
    return;
  }
  for(s=0;s<fsize;free(ftext[s]),s++);
  fsize=0;
  if(getfmem(fs)){
    winwords("     .\n");
    return;
  }
  while(fsize<fs){
    if(fread(&s,sizeof(unsigned long),1,f)!=1){
      winwords("  .\n");
      fclose(f);
      return;
    }
    if(newfun(fsize,s)){
      winwords("     .\n");
      fclose(f);
      return;
    }
    if(fread(fname+fsize*namelen,namelen,1,f)!=1||fread(ftext[fsize],s,1,f)!=1){
      winwords("  .\n");
      fclose(f);
      return;
    }
    ftext[fsize][s]=0;
    fsize++;
  }
  fclose(f);
  winwords(" !\n");
}
void save(unsigned char *filename){
  FILE *f;
  unsigned long i,len;
  winwords("    ");
  printf("%s...\n",filename);
  f=fopen(filename,"wb");
  if(!f){
    winwords("     .\n");
    return;
  }
  if(fwrite(FILE_VER,strlen(FILE_VER),1,f)!=1||fwrite(&size,sizeof(unsigned long),1,f)!=1){
    winwords("     .\n");
    fclose(f);
    return;
  }
  if(size){
    if(fwrite(data,size*sizeof(double),1,f)!=1||fwrite(name,size*namelen,1,f)!=1){
      winwords("     .\n");
      fclose(f);
      return;
    }
  }
  if(fwrite(&fsize,sizeof(unsigned long),1,f)!=1){
    winwords("     .\n");
    fclose(f);
    return;
  }
  for(i=0;i<fsize;i++){
    len=(unsigned long)strlen(ftext[i]);
    if(fwrite(&len,sizeof(unsigned long),1,f)!=1|| 
       fwrite(fname+i*namelen,namelen,1,f)!=1||
       fwrite(ftext[i],len,1,f)!=1){
      winwords("     .\n");
      fclose(f);
      return;
    }
  }
  fclose(f);
  winwords(" .\n");
}
void exprt(unsigned char *filename){
  FILE *f;
  unsigned long i,n;
  winwords("    ");
  printf("%s...\n",filename);
  f=fopen(filename,"w");
  if(!f){
    winwords("     .\n");
    return;
  }
  //fprintf("stack %d; numsyst %d\n",stacklevel,numsyst);
  for(i=0;i<size;i++){
    fprintf(f,"%s=",name+i*namelen);
    fwritenum(f,data[i],10);
    fprintf(f,"\n");
  }
  for(i=0;i<fsize;i++){
    fprintf(f,"func %s(",fname+i*namelen);
    n=0;
    while(ftext[i][n]!=';'){
      fprintf(f,"%c",ftext[i][n]);
      n++;
    }
    fprintf(f,")=%s\n",ftext[i]+n+1);
  }

  if(tree)fprintf(f,"tree on\n");  
  if(!err)fprintf(f,"errmsg off\n");
  if(stacklevel!=DEFAULT_LEVEL)fprintf(f,"stack %d\n",stacklevel);
  if(wrformat[0])fprintf(f,"wrformat %s\n",wrformat);

  fclose(f);
  winwords(" .\n");
}
void run(unsigned char *filename){
  unsigned long i,s,c;
  int ch;
  FILE *f;
  winwords("  ");
  printf("%s...\n",filename);
  f=fopen(filename,"rb");
  if(!f){
    winwords("     .\n");
    return;
  }
  fseek(f, 0, SEEK_END);
  s=ftell(f);
  fseek(f, 0, SEEK_SET);
  commands[0]=0;
  c=0;
  i=0;
  while (i<s){
    ch=getc(f);
    if (ch=='\n'||c==MAX-2||ch==';'){
      if(ch!='\n'){
        if(c==MAX-2)winwords("         !\n       .\n");
        commands[c]=ch;
        c++;
      }
      commands[c]=0;
      c=0;
      while(commands[0]){
        get_command(line,commands,';');
        docmd(line);
      }
    }else if(ch!=13&&ch!=0&&ch!=7&&ch!=1){
      commands[c]=ch;
      c++;
    }
    i++;
  }
  if(c>0){
    commands[c]=0;
    while(commands[0]){
      get_command(line,commands,';');
      docmd(line);
    }
  }
  fclose(f);  
  commands[0]=0;
  line[0]=0;
}
void home(){
  if(namelen>=MAX)winwords(" .\n");
  INF=0;
  INF=1/INF;
  IND=0;
  IND=0/IND;
  if(getmem(PLUS)||getfmem(PLUS)){
    winwords("   !\n");
    exit(1);
  }
  srand((unsigned int)time(NULL));
  printf("Pugachev Sekrasoft %s %s\n",PROG_NAME,VER);
  printf("-----------------------------------\n\n"
         "Type help to get help.\n");
  winwords("  :\n");
  run("hCalc.txt");
}
void end(){
  unsigned long i;
  winwords("  :\n");
  exprt("hCalc.txt");
  
  free(data);
  free(name);
  free(fname);
  for(i=0;i<fsize;free(ftext[i]),i++);
  free(ftext);
  fmax=0;
  fsize=0;
  max=0;
  size=0;
  exit(0);
}
void about(){
  unsigned char i;
  unsigned long b,n;
  printf("Pugachev Sekrasoft %s\n"
    "Program version:               %s\n"
    "File header (for load, save):  %s\n"
    "Stack level:                   %d\n"
    "Default stack level:           %d\n"
    "Default result variable:       %s\n"
    "String length:                 %d\n"
    "Variable/function name length: %d\n"
    "Variable size:                 %d\n"
    "Memory [+]:                    %d\n"
    "Write format:                  %s\n"
    "Show stack tree:               %d\n"
    "Show Math Errors:              %d\n"
    "PI~                            %g\n"
    "E~                             %g\n"
    "Math. Chars: ",
    PROG_NAME,VER,FILE_VER,stacklevel,DEFAULT_LEVEL,ANS,MAX,namelen,sizeof(double),PLUS,wrformat,tree,err,PI,E);
  for(i=0;i<255;i++)if(msymb(i))printf("%c ",i);
  printf("\n----------------------------------------------------------\n"
    "Current session:\n"
    "Variables: %d/%d\n"
    "Functions: %d/%d\n"
    "Bytes for variables: %d\n"
    "Bytes for functions: ",
    size,max,fsize,fmax,max*(sizeof(double)+namelen));
    b=fmax*namelen;
    for(n=0;n<fsize;b+=(unsigned long)strlen(ftext[n]),n++);
    printf("%d\n"
      "Bytes for strings:   %d\n",b,MAX*(2*sizeof(double)+7));
}
int __down(char *name){
  _down++;
#ifdef _dbg
  printf("%d STACK: \"%s\"\n",_down,name);
#endif
  if(time(NULL)>Time){
    Time=time(NULL);
    if(_kbhit()){
      if(err){
        winwords(" ");
        printf("%s",name);
        winwords("  .\n");
      }
      getchar();
      return 1;
    }
  }
  if(!stacklevel)stacklevel=DEFAULT_LEVEL;
  if(_down>stacklevel){
    winwords("hCalc.StackCheck:  ");
    printf("%s",name);
    winwords("     ");
    printf("%d.\n",stacklevel);
    return 1;
  }
  return 0;
}
